

#ifndef OUTPUTSHIFT_74595_HEADER
#define OUTPUTSHIFT_74595_HEADER

//---------------------------------------------
// 74HC595 OPUTSHIFT SECTION
//---------------------------------------------

#define NUMBER_OF_74595				3

#define TTL74595_DIR_REG_BITMSK	0x3C // 0b00111100
#define TTL74595_DIR_REG		DDRD
	
#define TTL74595_SERDATA_PORT	PORTD
#define TTL74595_SH_CP_PORT		PORTD
#define TTL74595_ST_CP_PORT		PORTD
#define TTL74595_MR_PORT		PORTD

#define TTL74595_MR_BIT			0x04	//Shift Reset ( Activ Low, clearsdata ion Shift Register) eigentlich unntig.
#define TTL74595_SH_CP_BIT		0x08	//Shift clock ( LowToHigh transition )
#define TTL74595_ST_CP_BIT		0x10 	//Latch Data to Output ( LowToHigh transition )
#define TTL74595_DS_BIT	0x20	//Daten rausshiften

#define TTL74595_INITDIRREG()	( TTL74595_DIR_REG |= TTL74595_DIR_REG_BITMSK )

#define TTL74595_MR_LOW()		( TTL74595_MR_PORT &= ~TTL74595_MR_BIT ) //Clear	ShiftReg mit HighFlanke RCK
#define TTL74595_MR_HIGH()		( TTL74595_MR_PORT |=  TTL74595_MR_BIT ) 	//Enable SHiftreg

#define TTL74595_DS_LOW()	( TTL74595_SERDATA_PORT &= ~TTL74595_DS_BIT ) //Daten rausshiften
#define TTL74595_DS_HIGH()	( TTL74595_SERDATA_PORT |= TTL74595_DS_BIT ) //Daten rausshiften

#define TTL74595_SH_CP_LOW()	( TTL74595_SH_CP_PORT &= ~TTL74595_SH_CP_BIT ) //Shift clock
#define TTL74595_SH_CP_HIGH()	( TTL74595_SH_CP_PORT |= TTL74595_SH_CP_BIT ) //Shift clock

#define TTL74595_ST_CP_LOW()	( TTL74595_ST_CP_PORT &= ~TTL74595_ST_CP_BIT ) // Latch Data to Output
#define TTL74595_ST_CP_HIGH()	( TTL74595_ST_CP_PORT |= TTL74595_ST_CP_BIT ) // Latch Data to Output

typedef union
	{
	uint32_t gu32TTL74595; //Selber Speicherplatz
	uint8_t gau8TTL74595[ NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister	
	}SU_SHIFT_TTL74595_TYPE;
//GLOBAL

extern SU_SHIFT_TTL74595_TYPE gSU_TTL74595;	//Gobales struct union Array mit Bytezahl der benutzen Shiftregister
extern void Write_OUT74HC595( uint8_t * pca74HC595 );  // mit pointer auf array

#endif //OUTPUTSHIFT_74595_HEADER