

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"21.02.2011"
#define FUNKTION	"Shift 74595 SW PORTB"
#define HARDWARE	"Atmel ATMega16 V3.3"
#define UHRZEIT	"12:00"
#define AUTOR		"Christof Ermer"
#define BAUDRATE	"BAUD 9600 8N1"

#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"

/*  HISTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
//#include <compat\deprecated.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
#include "uart.h"
#include "74595.h"



#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
uint32_t GetTickDifference(uint32_t u32Time);
#endif


#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);

void PrintStrCR(const char* pStr);
void Print_PStrCR(PGM_P pmStr);
void CheckOrder(char* pcStr);
void LongToNumStr(int32_t lVal);
void PrintLongCR(int32_t lVal);
void FloatToNumStr(double fVal);
#endif

//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
// GLOBALE VARIABLEN 
uint8_t gu8ProgMode;
//MSG
const char MCA_DELIMITER[] PROGMEM	= ",";

const prog_uint8_t MCA_ShiftLR[] PROGMEM = 
{
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
};

const prog_uint8_t MCA_STARTREK[] PROGMEM = 
{
0x81,0x42,0x24,0x18,0x24,0x42
};

const prog_uint8_t MCA_Blink[] PROGMEM = 
{
0xAA,0x55
};


const prog_uint32_t UpDown[] PROGMEM = 
{
0x00000001,0x00000002,0x00000004,0x00000008,0x00000010,0x00000020,0x00000040,0x00000080,
0x00000040,0x00000020,0x00000004,0x00000010,0x00000008,0x00000004,0x00000002,0x00000001,
};

uint16_t gu16WaitTicks;

#ifdef UART_USE_ENABLED 
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif




//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
volatile  uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#ifdef USE_ERROR_FLAG 
uint8_t gbErrorFlag;
#endif


#ifdef TIMER_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32_Ticks++;
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();

TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32_Ticks = 0;
OCR2 = 0;
TCNT2 = 0;  //Timer MAX = TOP Compare
TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};






#ifdef UART_USE_ENABLED 
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bit_MSK) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG 
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  PSTR("UartErr") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif




#ifdef UART_USE_ENABLED 
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED   //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_putc( ASC_CR );
};


// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
//sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
ltoa(lVal, gcaNumStr, 10 );
};

// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif



// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	Print_PStrCR( PSTR("PONG") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("XX") )  )
	{	
	PrintLongCR( gu32_Ticks );
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT") )  )
	{	
	gu16WaitTicks = (uint16_t)gsCmd.fCmdVal_1;	
	uart_puts_p( PSTR("Warte auf Ticks ist nun:") );	
	PrintLongCR( gu16WaitTicks );
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("LL") )  )
	{	
	gu8ProgMode |= STATE_FLAG_LINKSRUM;
	Print_PStrCR( PSTR("* Linksrum *") );
	
	};
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RR") )  )
	{	
	gu8ProgMode &= ~ STATE_FLAG_LINKSRUM;
	Print_PStrCR( PSTR("* Rechtsrum *") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SL") )  )
	{	
	gu8ProgMode = USE_SHIFT_LINEAR	;
	Print_PStrCR( PSTR("USE_SHIFT_LINEAR") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("UD") )  )
	{	
	gu8ProgMode = USE_SHIFT_UPDOWN;
	Print_PStrCR( PSTR("USE_SHIFT_PATTERN") );	
	};
 };




// *******************************************************************
// *******************************************************************
int main(void)
// *******************************************************************
// *******************************************************************
{
static uint32_t u32Now;
uint8_t u8NN;
uint8_t u8NShiftReg;

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUT_MSK;
PORTA = PORTA_PRESET_PULL_MSK;
DDRB = PORTB_DDRX_OUT_MSK;
PORTB = PORTB_PRESET_PULL_MSK;
DDRC = PORTC_DDRX_OUT_MSK;
PORTC = PORTC_PRESET_PULL_MSK;
DDRD = PORTD_DDRX_OUT_MSK;
PORTD = PORTD_PRESET_PULL_MSK;

gu32_Ticks = 0;


//SFIOR = (1<<PUD); //Pullup Disable

StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );

u32Now = 0;

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(FUNKTION) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(BAUDRATE) );
Print_PStrCR( PSTR(IHAVENOBRAIN) );
Print_PStrCR( PSTR(USEYOURS) );
	
//Anfangsbedingung stellen	
gu16WaitTicks = 24	; // 1/10 Sekunde
DDRC = 0xFF;
TTL74595_INITDIRREG();

gu8ProgMode = USE_SHIFT_LINEAR;
u8NShiftReg = 0;
u8NN = 0;

//uint8_t u8PatternSize;
//PGM_P pgmpPattern;
// ************ MAIN LOOP *********************
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
// ************ MAIN LOOP *********************
	{	
	sei();
 	wdt_reset();	//WATCHDOG!
	
	if( (gu32_Ticks - u32Now) > gu16WaitTicks ) //Hier kann was gperiodisch gemacht werden
		{
		u32Now = gu32_Ticks; //Zeit merken !!	
			
		if( gu8ProgMode & USE_SHIFT_LINEAR )
			{
			if(  u8NN >= 8 )	//Ende erreicht
				{
				u8NShiftReg++;  //Weiterstellen
				u8NShiftReg %= NUMBER_OF_74595;	
				u8NN %= 8;
				};	
			gSU_TTL74595.gau8TTL74595[ 0 ] = 0;
			gSU_TTL74595.gau8TTL74595[ 1 ] = 0;
			gSU_TTL74595.gau8TTL74595[ 2 ] = 0;
			gSU_TTL74595.gau8TTL74595[ u8NShiftReg ] = (1UL << u8NN); 	//Wert in Array Schreiben			
			Write_OUT74HC595( gSU_TTL74595.gau8TTL74595 ); 	//Ausgeben
			u8NN++;
			};			
			
///MCA_32SHIFT_PATTERNS[] PROGMEM = 	// 1 Schieben fr Fr 3 BYTE
//uint32_t  * gpgmShiftParser;
		};
	
	}; //main loop Ende
};
// ******************* MAIN END ********************************************

