
#include <avr/sfr_defs.h>
#include <avr\io.h>

#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>

#include "ADC.h"			//with Hardware assigns

#ifdef ADC_USED_ENABLED
//****************************************************************
uint16_t ADC_AT16_10Bit(uint8_t u8Chan) // 0..7
//****************************************************************
{
DDRA &=	~(1<< u8Chan);  //Bit loeschen
PORTA &= ~(1<< u8Chan); //Wegen Pullup abschalten
ADCSRA = (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1) | (1<< ADPS0);   //ADC EIN UND PreScaler
#ifdef ADC_EXTERN_5V_USED_ENABLED
ADMUX =  u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_5V_AN_C_USED_ENABLED
ADMUX =  (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_INTERN_BANDGAP_USED_ENABLED
ADMUX = (1<< REFS1) | (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
_delay_us(1);
ADCSRA |= (1<< ADSC);	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & (1<< ADSC) )	//wait until _BV(ADSC)=0 =converstion completed
	{
	wdt_reset();
	};	
return ADC;	//ADCW; //get converted value
};
#endif


