

#define SOFTWARE	"RingBuf16.c"
#define DATUM		"13.01.2019"
#define AUTOR		"** Christof Ermer **"

#include <avr\io.h>
#include <stdint.h>
#include <stdlib.h>

#include "main.h"  
//#include "RingBuf16.h"

/* Umgewandelt in allgemeine RingBuffer funktion, mit Struktur Pointer
1. Type anlegen 
RINGBUF_TYPE  gsRxRingBuf;
2. Instanz Initialisieren mit Grsse 2^n
Init_RingBufBuf( &gsRxRingBuf, 256U );
*/

//#define RINGBUFF_SIZE 64 //2^n
// ACHTUNG uxArraySize = > 8 BIT weil 256 mglich sein muss
// *********************************
void RingBuf_Init(RINGBUF_TYPE * pRBuf, uint16_t * pu16Buffer, uint8_t uxArraySize) //always N^2 Size
// *********************************
{
pRBuf->uxHead=0;
pRBuf->uxTail=0;	//uxHead = uxTail;
//U16ArraySize Immer N^2 BUF_STRMAX never >256,  or change the Datatype from  HEAD & TAIL to "unsigned int". 
// test if the size of the circular buffers fits into SRAM
pRBuf->uxRingBufMask = uxArraySize - 1;
//if( (pRBuf->pauRingBuf = (uint8_t*) malloc( u16ArraySize ) ) == NULL )
pRBuf->pauRingBuf =  pu16Buffer;
*(pRBuf->pauRingBuf) =  0;
};
// *********************************


// *********************************
void RingBuf_Flush(RINGBUF_TYPE * pRBuf)
// *********************************
{
pRBuf->uxHead=0;
pRBuf->uxTail=0;	//uxHead = uxTail;
};


//IMMER !!vorher Testen ob Platz,damit Zeichen nicht verloren geht.
// *********************************
void RingBuf_WriteC(RINGBUF_TYPE * pRBuf, uint16_t u16Rx)  //Rckgabeflag: Ok--> 0
// *********************************
{ // & uxRingBufMask ist Limit Size
pRBuf->uxHead = (pRBuf->uxHead + 1) & pRBuf->uxRingBufMask;
*(pRBuf->pauRingBuf + pRBuf->uxHead) = u16Rx ;	
};



// *********************************
uint32_t RingBuf_ReadC( RINGBUF_TYPE * pRBuf )
// *********************************
{
if( pRBuf->uxHead == pRBuf->uxTail )
	{
	return RING_NO_DATA;
	};
/* calculate /store buffer index */	
pRBuf->uxTail = (pRBuf->uxTail+1) & pRBuf->uxRingBufMask; 
/* get data */
return *(pRBuf->pauRingBuf + pRBuf->uxTail);    
};


// **************************
extern uint8_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf) /* Bytes im RingBuf ? */
// **************************
{ // Hier Modulo  % pRBuf->uxRingBufMask
return ((pRBuf->uxRingBufMask + pRBuf->uxHead - pRBuf->uxTail) % pRBuf->uxRingBufMask);
}; 

