


WriteLCD(1,"LCD AUSGABE");
WriteLCD(2,gcaNumStr);
		
#define lcd_e_delay()   __asm__ __volatile__( "rjmp 1f\n 1:" );   //#define lcd_e_delay() __asm__ __volatile__( "rjmp 1f\n 1: rjmp 2f\n 2:" );


/*************************************************************************
 delay loop for small accurate delays: 16-bit counter, 4 cycles/loop
*************************************************************************/
static inline void _delayFourCycles(unsigned int __count)
{
    if ( __count == 0 )    
        __asm__ __volatile__( "rjmp 1f\n 1:" );    // 2 cycles
    else
        __asm__ __volatile__ (
    	    "1: sbiw %0,1" "\n\t"                  
    	    "brne 1b"                              // 4 cycles/loop
    	    : "=w" (__count)
    	    : "0" (__count)
    	   );
}


		// **********************************************
int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};




//0010 1000 = 0x28
//0001 0001 = 0x12
//0010 0100 = 0x24
//0001 0010 = 0x12
//const uint8_t MCA_WAVEDRIVE[] PROGMEM = {0x28,0x12,0x24,0x12};	//CONST ARRAY
//FULLSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0011 1001 = 0x39
//0011 0101 = 0x35
//0011 0110 = 0x36
//const uint8_t MCA_FULLSTEPS[] PROGMEM = {0xBA,0xB9,0xB5,0xB6};	//CONST ARRAY
const uint8_t MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36};	//CONST ARRAY
//HALFSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0010 1000 = 0x28
//0011 1001 = 0x39
//0001 0001 = 0x11
//0011 0101 = 0x35
//0010 0100 = 0x24
//0011 0110 = 0x36
//0001 0010 = 0x12
const uint8_t MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};	//CONST ARRAY


STEPCTRL_PORTX =  
		(STEPCTRL_PORTX & (~STEPAMP_ALLCTRL_MASK))	| //ODER . erhalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gucStepPars % gucModePatternModulo) ) ) ); 	
		
		
	#if   EEPROM_USED == 1
// ****************************************************************
void SaveParameter(void)
// ****************************************************************
{
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=0;
strcpy_P(gcaStr, MCA_EEPROM_STR);
strcat_P(gcaStr, MCA_VALID_STR);
cli(); // Schalte Interrupts aus !!
//void eeprom_write_word (uint16_t *addr, uint16_t val)
eeprom_busy_wait();
eeprom_write_word( &guiEEPDUMMY, EE_DUMMYLOAD); //IN 0 NIX LADEN
//uiAdr=2;//Next Adress
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((uint8_t*)gcaStr, &gucaEEPStr, sizeof(gucaEEPStr) );
//uiAdr+=uiSize;
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
uart_puts_p( MCA_EEPROM_STR );
Print_PStrCRLF(MCA_SAVE_STR);
#endif
};
#endif


#if   EEPROM_USED == 1
//EE
// *******************************************************************
int CheckEEPROM_Valid(void)
// *******************************************************************
{//return 0 = Fehler
uint16_t uiDummy; 
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=2;
//Hilfsweise gcaNumStr.
strcpy_P(gcaNumStr, MCA_EEPROM_STR);// DAS MUSS DRINSTEHEN
strcat_P(gcaNumStr, MCA_VALID_STR); // DAS MUSS DRINSTEHEN
cli(); // Schalte Interrupts aus !!
eeprom_busy_wait();
uiDummy = eeprom_read_word(&guiEEPDUMMY); // 1. Dummy read 
//eeprom_read_block( (char*)gcaStr, &gucaEEPStr, (strlen(gcaNumStr) + 1) );
eeprom_busy_wait();
eeprom_read_block( &gcaStr[0], &gucaEEPStr, sizeof(gucaEEPStr) );
sei(); // Schalte Interrupts wieder an !!
*(gcaStr + strlen(gcaNumStr))= 0;	// [12]-1=11	 //Terminiere
if( strncmp(gcaStr ,gcaNumStr,strlen(gcaNumStr)) ) //EEPROMVAILD --> Cmp=0
	{//!=
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_STR );
	uart_puts_p( MCA_SPACE_STR );
	Print_PStrCRLF( MCA_WRONG_STR );
#endif
	//SaveParameter();
	return 0;		
	}
else
	{//OK
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_STR );
	uart_puts_p( MCA_SPACE_STR );
	Print_PStrCRLF( MCA_OK_STR );
#endif
	return 1;
	};
};
#endif

#if   EEPROM_USED == 1
// ****************************************************************
void LoadParameter(void)
// ****************************************************************
{
if( CheckEEPROM_Valid() )
	{
	cli(); // Schalte Interrupts aus !!
//void  eeprom_read_block (void *buf, const void *addr, size_t n)
	eeprom_busy_wait();
	eeprom_read_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
	sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_STR );
	Print_PStrCRLF( MCA_LOAD_STR );
#endif
	};
};
#endif 


if ADC_USED_ENABLED == 1
//****************************************************************
uint16_t ADC_10Bit(uint8_t ucChan)
//****************************************************************
{
//unsigned int sreg;
//sreg = SREG;
//cli();
//Wegen mglichem zugriffffehler auf Port A
DDRA = DDRA & ~(1<<ucChan);   //port A Chanel Bit Input  
PORTA = PINA & ~(1<<ucChan); //Wegen Pullup
  // Activate ADC with Prescaler 16 --> 1Mhz/16 = 62.5kHz
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
 // Select pin ADC0 using MUX
ADMUX = (ucChan & ADC_MUX_MASK);
    
    //Start conversion
ADCSRA |= _BV(ADSC);

//SREG = sreg;
    // wait until converstion completed
while (ADCSRA & _BV(ADSC) ) 
	{
	wdt_reset();
	};	   
return ADC;// get converted value
};
#endif	



// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
sprintf(gcaNumStr,"%.1f", fVal);
};

OCR1A = (uint16_t)Round( (PULS_PER_SECOND_T1 * (1.0 / *pfVal) ) );





