

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include <avr\interrupt.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>
#include <math.h>


#include "avr_register.h"
#include "main.h"
#include "debounce.h"

//Global
SWITCH_STRUCT_TYPE gsSWITCH;

#ifdef INTERRUPT_USED
//************************	****************************************
SIGNAL( INT1_vect ) //SIGNAL(SIG_INTERRUPT1)// signal handler for external interrupt int1
//*******************************************************************
{
uint8_t u8sreg;
u8sreg = SREG;
cli();
if( gsSWITCH.ucSWITCHFlag & SWITCH_RELEASED )
	{
	GICR &= ~(1 << INT1); // deaktiviert external  INT 1 ();
	//gi32SM_Pos = 0;
	gsSWITCH.ucSWITCHFlag |= SWITCH_Index_VALID;	
//1. TEIL. PRESSED SECTION
	gsSWITCH.ucSWITCHFlag = SWITCH_INT_EVENT  | SWITCH_PRESSED_DETECT; //Tastenzustand merken und sofort AKTION AUSLSEN...
	};
GIFR |= (1 << INTF1) ; //alten Intevent lschen 
SREG  = u8sreg; 
sei();
};
#endif


// *******************************************************************
void Check_Switch(void)
// *******************************************************************
{	
//================================================================================		
//2. TEIL. RELEASE SECTION

#ifdef INTERRUPT_USED
if( ((INTx_INPORT & _BV(INT1_PIN_NR)) == 0) && // LOW gelesen
	//Reicht nicht, weil taster ja Durch Prellen kurz Released sein kann..	
	!( gsSWITCH.ucSWITCHFlag & (SWITCH_RELEASED_DETECT | SWITCH_RELEASED) ) // keins davon
)
	{
	gsSwitch.ucSWITCHFlag &= ~SWITCH_PRESSED; //Tastenzustand merken und sofort AKTION AUSLSEN...
	gsSwitch.ucSWITCHFlag |= SWITCH_RELEASED_DETECT;
	gsSwitch.ulEventTime = gu32_Ticks; //MERKE DIR DIE ZEIT
//Toggle_BIT( 0, 3 );
	};
//3. Teil RELEASED?
if( ((INTx_INPORT & _BV(INT1_PIN_NR)) == 0) && // Wieterhin nicht gedrckt
	(gsSwitch.ucSWITCHFlag & SWITCH_RELEASED_DETECT) &&	
	( (gu32_Ticks - gsSWITCH.ulEventTime) > SWITCH_SWITCH_RELEASE_DELAY_TICKS) //SEC
)
	{
	gsSwitch.ucSWITCHFlag = SWITCH_RELEASED;	//Setzte Released							
	//Aktiviere wieder INT1
	GIFR |= (1 << INTF1) ; //alten Intevent lschen 
	GICR |= (1 << INT1) ; // explizit einschalten
	};
};
