

// Version 21.01.2019
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define DATUM		"22.01.2019"
#define SOFTWARE	"Morse-Sender-Receiver-V1.3"
#define HARDWARE	"Arduino-UNO ATMega328"
#define AUTOR		"Christof Ermer"
#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		" Use your own!"

#include "main.h"

//#define LED1_BLINK (1<<PB5)	//LED an BIT 0
// GLOBALE VARIABLEN 

volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8ProgStatusFlags;
const char MCA_LCD_16SPACE[] PROGMEM = "                ";  // 16 Leer Stellen

// Interrupt Section
/*
IDEE  72KHz Interrrupt ist Zeitnormal, vergleich fr MorseZeit
1. gu16_M01_Ticks=0;
Toglge OC1A = TON
*/

// ***************************
ISR( TIMER0_COMPA_vect )  //72KHZ
/// ***************************
{//Schneller Teil
//uint8_t u8Sreg = SREG;
volatile static uint32_t u32Merke_T;
volatile static uint32_t u32TX_Text_T;
gu32_Ticks++;
//LEDLeisteTx( gu8Morse_Flags_Tx );

if( ( gu32_Ticks - u32Merke_T) > (TICK_1000MS))
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8ProgStatusFlags |= STATUS_TICK_EVENT;
	};

if( (gu32_Ticks - u32TX_Text_T) > (TICK_1000MS * 2))  // 30 Sekunden
	{
	u32TX_Text_T = gu32_Ticks;	//neue Zeit merken
	gu8ProgStatusFlags |= STATUS_TICK_TX_TEXT;
	};

if( gu8Morse_Flags_Tx & MORSE_01TX_AKTIV)
	{		
	if(gu16_M01_Ticks > gu16_M01_Duration)  // Ende erreicht
		{		
		BEEPDATA_OFF();
		CLR_LAMPE();
		BEEPTON_OFF();		
		gu8Morse_Flags_Tx &= ~MORSE_01TX_AKTIV;
		};
	gu16_M01_Ticks++;	
	};
//SREG = u8Sreg;
};  // int

/*
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
};
*/

// *************
int main(void)
// *************
{
uint32_t u32CPULast=0;
char ucaTxText[80];
INTLED_INIT();
MorseRx_Init();
MorseTxInit();  //Macht alle Timer und  DDRx

wdt_reset();  
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
ResetRxBuff();

wdt_reset();   //WATCHDOG!
// TWI initialisieren
i2c_init();
//MAX7219_Init();
//MAX7219_Clear();	

// LCD initialisieren
lcd_init();

// LCD-Anzeige loeschen
lcd_command(LCD_CLEAR);

// Hintergrundbeleuchtung an
lcd_backlight(ON);

// Text auf LCD ausgeben
// MIT RAM , als falsch
strcpy_P( gcaStr, PSTR("* I2C LCD *") );
	lcd_printlc(1,1,(unsigned char *)gcaStr);
strcpy_P( gcaStr, PSTR("*Christof Ermer*"));
	lcd_printlc(2,1,(unsigned char *)gcaStr);

///TickCounter Starten
/*  verlegt zum Morsecounteer
TCNT2=0; //Bei NULL starten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
TCCR2B = (1 << CS22) | (1 << CS21); //Vorteiler //256 einschalten
*/
sei();

CRLF();uart_puts_p( PSTR( DATUM ) );
CRLF();uart_puts_p( PSTR( SOFTWARE ) );
CRLF();uart_puts_p( PSTR( HARDWARE ) );
CRLF();uart_puts_p( PSTR( AUTOR ) );
CRLF();uart_puts_p( PSTR("\r\n XX-->Sende Tastendruck bis ''#'' Zeichen\r\n:"));

//Handle_TX_Morse( IHAVENOBRAIN );
//Handle_TX_Morse( USEYOURS );
//Handle_TX_Morse( "SOS" );

CRLF();
uart_puts_p(PSTR("MORSE_CODES_IN_TABLE:"));
ultoa( MORSE_CODES_IN_TABLE, gcaNumStr, 10 );
uart_puts(gcaNumStr);

CRLF();
uart_puts_p(PSTR("Punkt=100mS, Strich= 300mS"));
	
for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!
	u32CPULast++;
//Toggle_Bit(1);
	if( gu8ProgStatusFlags & STATUS_TICK_EVENT )
		{
		gu8ProgStatusFlags &= ~STATUS_TICK_EVENT;
		//TOGGLE_INTLED();
		//SET_INTLED(); 

CRLF();
ultoa( u32CPULast, gcaNumStr, 10 );
u32CPULast=0;
uart_puts( gcaNumStr );

uart_puts_p( PSTR(" \t") );
uart_puts( ByteToBin( gu8Morse_Flags_Rx ) );

		//CRLF();uart_puts_p(PSTR("Morse FLAGS->"));
		//uart_puts(  ByteToBin( gu8Morse_Flags_Tx ) );  
		};

if( (gu8ProgStatusFlags & STATUS_TICK_TX_TEXT) && 
	!(gu8Morse_Flags_Tx & (M_TX_STRING_AKTIV | M_TX_CHAR_AKTIV) )
)
	{
	gu8ProgStatusFlags &= ~STATUS_TICK_TX_TEXT;	

CRLF();
uart_puts_p( PSTR("Flg:") );
ultoa( gu8Morse_Flags_Tx, gcaNumStr, 10 );
uart_puts( gcaNumStr );
//	Tx_MorseChar( 'A' );
	//Tx_MorseChar( 'A' );
	//Tx_MorseChar( 'B' );
	
	strcpy_P(  ucaTxText, PSTR("NCC1170 - Junikfer an Wallkre, der Pirol pfeift heute Nacht") );
	Handle_TX_Morse(  ucaTxText );
	};

//	lcd_printlr(1,1,(unsigned char *)gcaStr);
//	lcd_printlr(2,1,(unsigned char *)gcaStr);
//ultoa( gu32_Ticks, gcaNumStr, 10 );
//lcd_printlr(2,1,(unsigned char *)gcaNumStr);

	if( !(gu8Morse_Flags_Rx & M_RX_SLEEPS) ) // Reset in IR Interrupt
		{
		CheckMorse_RX_Status(); //on/Off Zeiten prfen, Ringbuf leeren etc.
		};
		
	UART_RX_Check();
	if(gu8ProgStatusFlags & STATUS_ORDER_FLAG)
		{
		CheckOrder();//gcaRxStr = accumulated str
		ResetRxBuff();
		};
	//CLR_INTLED();
	}; //for
}; // main
