

// Verison 17.01.2019

#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER
	
#include <avr/sfr_defs.h>
#include <stdlib.h>
#include <avr\io.h>
#include <util\delay.h>
#include  <ctype.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <string.h> 
#include <avr/pgmspace.h>
#include <math.h>
#include "PCF8574.h"
#include "uart328.h"
#include "i2cmaster.h"
#include "i2clcd.h"
#include "debug.h"
#include "Befehle.h"
#include "Morse_TxRx.h"
#include "MorseCodeTab1Byte.h"
//#include "RingBuf16.h"

// Hardwareassignment
//#define UART_#_RATE		38400
//#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	2400
//#define UART_BAUD_RATE	19200U
#define UART_BAUD_RATE	115200UL	//UART_BAUD_SELECT_DOUBLE_SPEED

//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3

//=============================
#define WDTO_2S   7 //WatchDog
//=============================

//RUNDUNG
//16MHZ /72000 -> 222.2222222... = oCR0A=222
// 16000000 / 244 = ~72072
#define TICK_1000MS	72072UL
//#define TICK_100MS	7207U

/*
// 16000000 / 256 = ~244
#define TICK_10SEKUNDEN 2441U
#define TICK_2000MS 488U
#define TICK_1500MS 366U
#define TICK_1000MS 244U
#define TICK_500MS 122U
#define TICK_250MS 61U
#define TICK_100MS 24U
#define TICK_50MS 12U
#define TICK_25MS 6U
#define TICK_10MS 2U
*/

#define STATUS_TICK_EVENT		0x01
#define STATUS_TICK_MSG_FLAG	0x02
#define STATUS_TICK_TX_TEXT		0x04
#define STATUS_ORDER_FLAG		0x08
//gu8ProgStatusFlags;

//INTERNE LED
#define INTLED_NR		5
#define INTLED_PORT		PORTB
#define INTLED_DDR		DDRB
#define INTLED_INIT() 	(INTLED_DDR |= (1<<INTLED_NR))
#define TOGGLE_INTLED()	(INTLED_PORT ^= (1<<INTLED_NR))
#define SET_INTLED()	(INTLED_PORT |= (1<<INTLED_NR))
#define CLR_INTLED()	(INTLED_PORT &= ~(1<<INTLED_NR))


volatile uint32_t gu32_Ticks;//  T2 timeCounter
extern volatile unsigned char gu8ProgModeFlag;

extern volatile uint8_t gu8ProgStatusFlags;

#endif  //MAIN_HEADER
